// ****************************************************************************
//             Copyright (C) Oasys Design Systems, Inc. 2004 - 2008
//                             All rights reserved.
// ****************************************************************************
#ifndef LLOADTYPES
#define LLOADTYPES

#include "UString"
#include "UHash"
#include "UAgg"
#include "UList"
#include "UPair"

typedef UHashMap<UString, int>     LLoadPinMap;
typedef LLoadPinMap::iterator      LLoadPinMapIter;
typedef UHashMap<UString, int>     LLoadBundleMap;
typedef LLoadBundleMap::iterator   LLoadBundleIter;
typedef UHashMap<UString, UAggType*>  LLoadBusMap;
typedef LLoadBusMap::iterator      LLoadBusIter;
typedef UPair<UString, UString>    LLoadRail;
typedef UList<UPair< UString,UString> > LLoadRailList;
typedef LLoadRailList::iterator    LLoadRailIter;

inline int
LLoadIndexAdjust(const char* nm, LLoadBundleMap* bundles, LLoadBusMap* busses,
		 UAggType* busType, int grpIdx) {
  if (bundles) {
    LLoadBundleIter biter = bundles->find(nm);
    if (biter) {
      uassert (grpIdx >= 0 && grpIdx < biter.value());
      return grpIdx;
    }
  }
  if (busses) {
    LLoadBusIter biter = busses->find(nm);
    if (biter) {
      uassert (busType == biter.value());
      return grpIdx;
    }
  }
  return 0;
}

#endif

